From jg Tue Feb 17 06:33:49 1987
Date: Tue, 17 Feb 87 06:33:31 est
From: jg (J. G. Wang CETL)
To: fred
Subject: MFM-SFTER1.ASM
Status: R


MFM_SFTERR.ASM_WD5710
	.TITLE	MFM-SFTER1.ASM FOR 1571CR
	.PW 	120
;*******************************
;*                             *
;* DDDD    IIII   SSSS  KK  KK *
;* DD  DD   II   SS  SS KK KK  *
;* DD  DD   II   SS     KKKK   *
;* DD  DD   II    SSSS  KKK    *
;* DD  DD   II       SS KKKK   *
;* DD  DD   II   SS  SS KK KK  *
;* DDDD    IIII   SSSS  KK  KK *
;*                             *
;*******************************
;*                             *
;* TTTTTT EEEEEE  SSSS  TTTTTT *
;*   TT   EE     SS  SS   TT   *
;*   TT   EE     SS       TT   *
;*   TT   EEEE    SSSS    TT   *
;*   TT   EE         SS   TT   *
;*   TT   EE     SS  SS   TT   *
;*   TT   EEEEEE  SSSS    TT   *
;*                             *
;*******************************
;
;
;
;*******************************
;*			       *
;* SOFT ERROR TEST FOR SYSTEM  *
;*       MODEL 1571CR	       *
;*			       *
;*    === MFM FORMAT ===       *
;* 			       *
;* 			       *
;*      C.L.FANG (CETL)        *
;*        FEB-17-1987	       *
;*******************************
;
; *** UPDATE NOTES ***
;
; THIS PROGRAM FOR 1571CR IS A REVISION OF JTP-047,
; ONLY READ, WRITE & VERIFY ROUTINES ARE CHANGED,
; AND SOME CODES FOR INITIALIZATION ADDED.
;
;
;
;*******************************
;*                             *
;* SOFT ERROR TEST FOR SYSTEM  *
;*        MODEL 1571           *
;*                             *
;*          JTP-047            *
;*                             *
;*    ===  MFM FORMAT  ===     *
;*                             *
;*                             *
;*       RIMI MIYAJIMA         *
;*    COMMODORE JAPAN LTD.     *
;*         SEP/30 '85          *
;*                             *
;*******************************
;
;
;
; ***  ALL LOCATIONS ARE IN DOS MEMORY  ***
;
;
;
; JTP047 REV 1.0.0   SEP.30,1985   RIMI MIYAJIMA (CJL)
	; 
; *****  1571 SOFT ERROR TEST  *****
;
;
;
; === PROGRAM IS STARTED AT $406 ===
;
;
;
; ******************************
; *  DEFINITIONS AND EQUATES   *
; ******************************
;
;
;
; ***  WORK FOR TEMP  ***
ADDR	.EQU	$6E
WK1	.EQU	ADDR+1
WK2	.EQU	ADDR+2
WK3	.EQU	ADDR+3
;
; ***  EQUATES  ***
BUFPNT:	.EQU	$30;READ/WRITE BUFFER($300-$3FF)
SWITCH	.EQU	$3B ;INFORMATION FOR DOS
SECTR	.EQU	$43 ;SECTOR
MFMSZH	.EQU	$44 ;SECTOR SIZE HI
MRETRY:	.EQU	$4B  ;MFM RETRY COUNT
CMDTRK	.EQU	$67 ;TRACK
;
MFMCMD	.EQU	$1B0 ;STATUS
CMDBUF	.EQU	$200 ;COMMAND BUFFER
MFMSZL	.EQU	$271 ;SECTOR SIZE LO
CMDSIZ	.EQU	$274 ;COMMAND SIZE
;
BUFL	.EQU	$300 ;BUFFER USED FOR LOG
LOGSEC	.EQU	15 ;LOG SECTOR
LOGTRK	.EQU	39 ;LOG TRACK
ERRLIM	.EQU	4 ;MAX # OF ERRORS ALLWD=ERRLIM*256
;
MAXTRK	.EQU	80 ;TOTAL TRACKS (+1) ON DISK
;
WRITE	.EQU	10  ;WRITE JOB CODE
READ	.EQU	9   ;READ JOB CODE
FORMAT	.EQU	8 ;FORMAT JOB CODE
;
; ***  I/O  ***
LEDPRT	.EQU	$1C00 ;OUTPUT PORT FOR LED.
LED	.EQU	$8 ;DRIVE LED
;
WDSTAT	.EQU	$2000 ;WD STATUS REG
WDTRK	.EQU	$2001 ;WD TRACK REG
WDSEC	.EQU	$2002 ;WD SECTOR REG
WDDAT	.EQU	$2003 ;WD DATA REG
;
; ***  DOS ROUTINES  ***
PRCMD	.EQU	$BF4E ;CONTROLLER
;
STMTR	.EQU	$879A ;START MOTOR
WTMTR	.EQU	$87B0 ;WAIT MOTOR
SEKE	.EQU	$87BA ;SEEK
CVSTAT	.EQU	$883C ;CONVERT STATUS
STRTWD	.EQU	$884E ;START WD (SEND COMMAND TO WD)
WAITDN	.EQU	$8861 ;WAIT FOR UNBUSY
SLOG	.EQU	$88F6 ;SEEK LOGICAL
SELSID	.EQU	$8932 ;SIDE SELECT
CMDONE	.EQU	$89BF ;COMMAND ONE (BUMP)
;
JSLOWD	.EQU	$A483 ;WAIT 40 USEC
;
TRNOFF	.EQU	$F98F ;TURN OFF MOTOR
;
; ***  VALIABLE PASSED BY CPU  ***
PASTYP  	.EQU	$400    ;PASS TYPE, R($89) W($8A),
  ;IF<128 THEN N=RD/WR PASS RATIO.
;
NUMPAS  	.EQU	$400+1	;NUMBER OF PASSES
;
PATERN  	.EQU	$400+2	;WRITE DATA PATTERN
;
NEWDSK  	.EQU	$400+3	 ;BITS 7,6 AS FOLLOWS:
 ;1,1: NEW DISK, FMT RQD, 1ST WRT.
 ;0,1: OLD DISK, NEW RUN, ZERO LOG.
 ;0,0: OLD DISK, CONTINUATION RUN.
;
RNDTRK  	.EQU	$400+4	 ;BITS 7,6 AS FOLLOWS:
 ;0,0: PURE SEQUENTIAL TRAK SEQNCE.
 ;1,0: PURE 'RANDOM' TRAK SEQUENCE.
 ;1,1: ALT 'RANDOM' / SEQENTIAL.
;
RESET 		.EQU	$400+5	;BIT7=1: RESET SYSTEM WHEN DONE.
;
;
;
     	    	  ;START ADDRESS
	;
; ***  LOCATIONS IN LOG BUFFER  ***
TOTPAS  .EQU	BUFL+2;TOTAL PASSES MADE
TOTERR  .EQU	BUFL+4;TOTAL ERRORS MADE
TRKERR  .EQU	BUFL+6;PIGEON HOLES OF ERRORS/TRACK
ERRTYP  .EQU	BUFL+$56;# OF ERRORS OF TYPE 0 TO 20
PAS100  .EQU	BUFL+$6A;PASSES/100
PASCNT  .EQU	BUFL+$6B;COUNT OF PASSES <100
ERRTIM  .EQU	BUFL+$6C;WHEN OCCURRED (PER 100 PASSES)
REVCNT  .EQU	BUFL+$94;TIMES EACH RECOVERY OCCURRED
BADFPC  .EQU	BUFL+$9E;FIRST PASS RETRY COUNT
FPCARY  .EQU	BUFL+$9F;PIGEON HOLES OF 1ST PASS ERRORS
;
;
;
; ***  ERROR CODES  ***
;
;   2 = SECTOR NOT FOUND
;   3 = NO ADDRESS MARK (NO SYNC)
;   7 = VERIFY ERROR
;   9 = HEADER BLOCK CHECK SUM ERROR
;
; ***  LED CODING  ***
;
;
;
;FAST CONTINUOUS BLINKING MEANS FORMATTING IN PROGRESS.
;
;SLOW CONTINUOUS BLINKING MEANS TEST IN PROGRESS.
;
;
;
;FAST BLINKING SEPARATED BY TIME DELAY MEANS:
;
; # OF BLINKS                MEANS
;
;    1             TEST COMPLETED (W/WO ERRORS).
;    2             EXCESSIVE (>5) 1ST PASS ERRORS.
;    3             LOG ACCESS FAILURE.
;    4             FORMATTING FAILLED.
	; 
; ***  START OF 1571 SOFT ERROR TEST  ***
;
;
	.ORG	$306
	SEI	;KILL INTERRUPT
	BIT	NEWDSK	;FORMATTING REQD?
	BPL 	STARTA ;NO, START TEST.
;
;
;
	LDA #%00100110 ;7 P=0 PARTIAL FORMAT
 ;6 I=0 INDEX MARK WRITTEN
 ;5 D=1 DOUBLE SIDE
 ;4 S=0 #SIDE
 ;3 /=0
 ;2 /=1
 ;1 /=1
 ;0 N=0 #DRIVE
	STA 	SWITCH ;LET DOS KNOW INFORMATION
;
	LDA #$80 ;7 M=1 MFM FLG
 ;6 T=0 SECTOR TABLE INCLUDED
 ;5-0 =0 LOGICAL STARTING SECTOR
	STA CMDBUF+3 ;(CMDBUF+5 DEFALT=256BYTES SECTOR SIZE)
	LDA	#$00
	STA	CMDBUF+4
	LDA	#$01	;256 BYTE SECTORS
	STA	CMDBUF+5
	LDA	#$27	;LAST TRACK NUMBER
	STA 	CMDBUF+6
	LDA	#$11	;# OF SECTORS
	STA	CMDBUF+7
;
	LDA #$08	;COMMAND SIZE
	STA CMDSIZ ;COMMAND SIZE
;
	LDA #FORMAT
	JSR PRCMD ;CONTROLLER
;
	LDA MFMCMD ;GET INFORMATION
	CMP #2 ;OK ?
	BCC 	STARTA
;
	LDX #4
	JMP BLINK ;FORMAT ERROR
;
;
;
STARTA JSR BUMPIT ;BUMP DRIVE.
	LDX #1
	STX FPASS ;FIRST PASS FLAG
	LDA #0
	STA PASALT ;INIT ALT RD/WR PASS FLAG.
	LDY PASTYP ;PRELOAD 'NTH PASS WRITE' CNTR.
	STY PASWRT
	JMP	MAIN	;MAIN PROGRAM START AT SAFE AREA
;
	.ORG	$406
	; 'MAIN'
; ***  DRIVER FOR ERROR TESTS AND PATTERN LOAD  ***
;
;
MAIN:	JSR	FILRUP	;CLEAR LOG BUFFER WITH ZERO
     	JSR LEDON	;TURN ON GREEN LED
	BIT NEWDSK ;CONTINUATION TEST?
	BVC MAINC ;YES, DO NOT ZERO LOG.
;
      	JSR WLOG ;WRITE ZEROED LOG.
MAINC LDA #MAXTRK ;START INWARDS
	STA LIMIT
	LDY #0
	STY TRACK ;BASE TRACK IS 0
;
	JSR PASS ;DO INWARDS PASS.
;
	LDA FPASS ;CHECK FOR FIRST PASS
	BEQ MAINA ;TO MAINA IF NOT
;
	LDA #0 ;1ST PASS, RESET FIRST PASS FLAG
	STA FPASS ;AND CHECK FOR 1ST PASS ERRORS
	STA NEWDSK
;
	LDA #5
	CMP BADFPC
	BCS MAINA ;IS OK
;
	LDX #2 ;FIRST PASS FAILURE.
	JMP BLINK ;BLINK FOREVER.
;
MAINA JSR PASCHK ;CHECK PASS COUNT
;
;
;
	LDA #$FF ;GO TO MAXTRK AND START OUTWARDS
	STA LIMIT
	LDA #MAXTRK-1
	STA TRACK ;BASE IS LAST-1
;
	JSR PASS ;DO OUTWARDS PASS.
;
	JSR PASCHK ;CHECK PASS COUNT
;
;
;
	JMP MAINC ;CONTINUE TILL ENDED (IN PASCHK)
	; 'PASS'
; ********************
; *                  *
; *       PASS       *
; *                  *
; ********************
;
PASS JSR RLOG ;GET LOG
;
	BIT NEWDSK ;CHECK FOR OLD DISK.
	BMI PASSC ;BIT7=1: 1ST PASS & JUST FMTD.
	LDX PASTYP ;CHK PASTYP: IF + DO 1WR & N RD.
	BMI PASSA ;IS FIXED READ OR WRITE.
	DEC PASWRT ;VARIABLE, DEC COUNT OF READS.
	LDX #READ ;PRESUME NEXT IS ALSO READ.
	LDA PASWRT ;ON MODULO 'PASTYP', DO WRT.
	BPL PASSA ;NOT YET, STILL READ.
	LDA PASTYP ;NOW IS WRITE TIME.  RESET CNTR.
	STA PASWRT
PASSC LDX #WRITE ;SET FOR WRITE PASS.
PASSA 	STX OPRTYP
	; 'TEST'
; ***  TEST  ***
;
;
;
TEST LDA TRACK ;COPY BASE
	STA CTRACK
;
TEST1 LDA CTRACK ;CURRENT TRACK.
	BIT RNDTRK ;RANDOM TRACKS?
	BPL TSTA ;NO, SEQUENTIAL.
	TAX ;YES
	LDA TRKTBL,X ;GET TRACK FROM TABLE.
TSTA STA TMPTRK ;SAVE ACTUAL TRACK.
	CMP #40 ;SIDE 1 ?
	BCC TSTB ;NO, BRANCH
	PHP
	SBC #40
	PLP
TSTB 	STA CMDBUF+3 ;TRACK
	STA CMDTRK
	LDA #0
	BCC TSTC ;BRANCH IF SIDE 0
	LDA #%00010000 ;SIDE 1 FLG
TSTC 	STA 	SWITCH
;
	LDA #14 ;MAX SECTOR
	STA CMDBUF+4
	STA 	SECTR
;
	JSR 	STMTR ;START MOTOR
	JSR 	SEKE ;SEEK
	JSR	WTMTR ;WAIT MOTOR
	JSR 	SELSID ;SELECT SIDE
	JSR 	SLOG ;SEEK LOGICAL
;
TSTD JSR QUE ;FIRE OFF THIS JOB
;
	LDA MFMCMD ;GET STATUS
	CMP #2 ;DONE, IS OK?
	BCC TSTX ;YUP, TO TSTX
;
	JSR RETRY ;NOPE, SEE IF CAN BE RECOVERED
	;
	TAX ;BACK FROM RECOVERY ATTEMPTS
	INC ERRTYP,X ;INC TYPE OF ORIGINAL ERROR
	BNE TSTF ;LIMITED TO 255
	DEC ERRTYP,X
TSTF INC TOTERR ;UPDATE TOTAL ERROR COUNT
	BNE TSTG
	INC TOTERR+1
	LDA TOTERR+1 ;CHECK # ERRORS
	CMP #ERRLIM ;LIMIT=(#ERRLIM)*256
	BNE TSTG ;OK
	LDA #1 ;AT LIMIT OF ERRORS, STOP TEST.
	STA NUMPAS
;
TSTG 	LDX	TMPTRK	;UPDATE ERRORS ON THIS TRACK
	INC TRKERR,X
	BNE TSTH ;LIMITED TO 255
	DEC TRKERR,X
;
TSTH LDX PAS100 ;INC ERRORS/100 PASSES.
	INC ERRTIM,X
	BNE TSTX ;LIMITED TO 255
	DEC ERRTIM,X
;
;
;
TSTX DEC CMDBUF+4 ;SECTOR UPDATE
	BPL TSTD ;NOT ALL YET
;
;
;
	JSR TRNOFF ;TURN OFF MOTOR
;
	INC CTRACK ;PRESUME GOING INWARDS
	LDA LIMIT
	BPL TSTY ;0=OUTWARD BOUND
	DEC CTRACK ;1=INWARD BOUND
	DEC CTRACK
;
TSTY 	CMP CTRACK ;END? (ACC)=LIMIT
	BEQ UPLOG ;YES, UPDATE LOG AND LEAVE
	JMP TEST1 ;NOT YET, DO NEXT TRACK
	; 'LOG'
; ***  UPDATE LOG  ***
;
UPLOG INC TOTPAS ;INCREMENT TOTAL PASSES
	BNE UPLB
	INC TOTPAS+1
;
UPLB INC PASCNT ;UPDATE # OF PASSES (MODULO 100)
	LDA #100
	CMP PASCNT
	BNE WLOG ;NOT 100 YET.
	LDA #0
	STA PASCNT
	INC PAS100 ;MODULO 100 PASS COUNT
;
;
;
; ***  WRITE LOG  ***
;
WLOG
	LDA #WRITE
	ORA #$40 ;SET LOG BIT
	STA OPRTYP
	JMP 	LOG
	;
; ***  READ LOG  ***
;
RLOG
	LDA #READ
	ORA #$40 ;SET LOG BIT
	STA OPRTYP
;
;
;
; ***  LOG SUB  ***
;
LOG
	LDX #LOGSEC
	LDY #LOGTRK
	STX CMDBUF+4 ;SECTOR
	STX 	SECTR
	STY CMDBUF+3 ;TRACK
	STY CMDTRK
;
	LDA #0 ;SIDE 0
	STA 	SWITCH
;
	JSR 	STMTR ;START MOTOR
	JSR 	SEKE ;SEEK
	JSR WTMTR ;WAIT MOTOR
	JSR 	SELSID ;SELECT SIDE
	JSR 	SLOG ;SEEK LOGICAL
;
	LDY #10 ;ERROR COUNTER
	STY WK3
;
;
;
LOGA JSR QUE ;START OPERATION
;
	LDA MFMCMD
	CMP #2 ;OK?
	BCC LOGB ;YUP
	DEC WK3 ;NO, ANOTHER TRY?
	BNE LOGA ;YUP
;
	LDX #3 ;POST 	LOG ACCESS FAILURE.
	JMP BLINK
;
;
;
LOGB JSR TRNOFF ;TURN OFF MOTOR
	RTS
	; 'RETRY'
; ********************
; *      RETRY       *
; ********************
;
;RETRY ATTEMPTS JOB AGAIN, UP TO TEN TIMES.
;
;IF THIS IS FIRST PASS (READ), # OF RETRIES IS
;RECORDED IN BADCNT.  IF FIRST PASS RETRIES
;EXCEED 5 THEN TEST IS ABORTED.
;
;
RETRY 	STA WK1 ;SAVE ORIGINAL ERROR TYPE
;
	LDX #0 ;RECOVERY TIME POINTER
	STX WK3
;
RTA INC WK3
;
	JSR QUE ;RETRY JOB
;
	LDA MFMCMD ;GET STATUS
	CMP #2 ;DONE. OK NOW?
	BCC RTC ;YES, TO RTC
	LDA WK3 ;NO, TEN RETRIES YET?
	CMP #10
	BCC RTA ;NO, TRY AGAIN
;
RTC DEC WK3 ;NORMALIZE RETRY COUNT TO 0-9.
	LDX WK3
	LDA FPASS ;SPECIAL RECORDING IF 1ST PASS
	BEQ RTF
;
	TXA ;DURING FIRST PASS, RECORD
	CLC ;# OF ERRORS BEYOND 1ST RETRY.
	ADC BADFPC ;ERROR COUNT FOR END OF 1STPASS
	STA BADFPC
;
	LDY TMPTRK ;ACTUAL TRACK IN TEST.
	TXA
	CLC
	ADC FPCARY,Y
	STA FPCARY,Y
;
RTF INC REVCNT,X ;UPDATE #RETRIES ARRAY
	BNE RTX ;LIMITED TO 255
	DEC REVCNT,X
;
RTX LDA WK1 ;RETRIEVE ORIGINAL ERROR
	RTS
; 'PASCHK'
; ********************
; *                  *
; *    PASS CHECK    *
; *                  *
; ********************
;
PASCHK LDA NUMPAS ;CHECK FOR LAST PASS
	BEQ PASSW ;IF STORED 0, WILL DO FOREVER.
	CMP #11 ;CHECK FOR 2N PASS COUNT.
	BCC PASSY ;TO PASSY IF <11 PASSES
	LDA PASALT ;>11 IS 2 PASS/COUNT.
	EOR #1
	STA PASALT
	BNE PASSZ ;ON ALT PASS.
PASSY DEC NUMPAS
	BEQ PASSX ;DONE, GO BLINK.
PASSZ LDA NUMPAS ;NOT YET DONE, CHECK FOR PURE
	AND #1 ;TRK SEQNCE AT ODD PASS COUNT.
	BEQ PASSR ;EVEN COUNT.
PASSW 	BIT RNDTRK ;PURE SEQUENCE IF BIT6=0.
	BVC PASSR ;BIT6=0 (OVF=0). PURE.
	LDA RNDTRK ;ALTERNATE RANDOM/SEQUENTIAL
	EOR #$80 ;TRACK SEQUENCE.
	STA RNDTRK
PASSR 	RTS
;
PASSX 	LDX #1 ;BLINK LED ONCE.
	JMP 	BLINK ;FOREVER
; 'PRCMD2'
; ********************
; *       JOB        *
; ********************
;
;
; 'SUB'
; ***  BLINK  ***
;
BLINK STX WK2 ;BLINK ROUTINE.
	JSR 	BUMPIT ;BUMP DRIVE.
	BIT RESET ;RESET SYSTEM?
	BMI ENDIT ;YES.
BLNA 	LDX WK2
	STX WK1
;
BLNB 	JSR LEDON ;SET LED ON.
	JSR 	LEDOFF ;SET LED OFF.
	DEC WK1
	BNE 	BLNB
	JSR WINK ;LONG OFF DELAY.
	JSR WINK ;LONG OFF DELAY.
	JMP 	BLNA ;FOREVER AND EVER, AMEN...
;
;
;
LEDON 	LDA #LED ;SET LED ON.
	ORA 	LEDPRT
	BNE WAIT
;
LEDOFF 	LDA #$FF-LED ;SET LED OFF.
	AND 	LEDPRT
WAIT 	LDX #128 ;MEDIUM DELAY.
WAITX STA 	LEDPRT ;UPDATE LED.
WAITY 	LDY #0
WINK ADC #0 ;LONG DELAY IF ENTERED HERE.
	ADC #0
	DEY
	BNE WINK
	DEX
	BNE WINK
	RTS
;
;
;
ENDIT 	JSR WAITY
	JSR WAITY
	JMP ($FFFC)
;
; ***  BUMP  ***
;
BUMPIT 	JSR STMTR ;START MOTOR
	JSR WTMTR ;WAIT MOTOR
	JSR CMDONE ;BUMP DRIVE
	JSR TRNOFF ;TURN OFF MOTOR
	RTS
;
;
;
; ***  FILL  ***
;
FILRUP LDY #0
	TYA
FILB STA 	BUFL,Y ; FILL 0
	INY
	BNE FILB ;DO FULL PAGE.
	RTS ;DONE.
	; 'TABLE'
; ***  WORK STORES  ***
;
OPRTYP 	.DS	1 ;CURRENT OPERATION
TRACK 	.DS	1 ;BASE TRACK
CTRACK 	.DS	1 ;CURRENT TRACK
LIMIT 	.DS	1 ;END TRACK OF TEST
FPASS 	.DS	1 ;FIRST PASS FLAG
PASALT 	.DS	1 ;ALT FLAG FOR 2N PASSES
PASWRT 	.DS	1 ;COUNTER FOR WRITE PASSES.
TMPTRK 	.DS	1 ;#TRACK STORE TEMP
RDVR	.DS	1 ;READ OR VERIFY FLAG(RD=0,VR=1)
;
;
;
; ********************
; *   TRACK TABLE    *
; ********************
;
TRKTBL
 .BYTE 10,60,16,40,01,50,39,44,21,63,12,46,07,53
 .BYTE 28,78,05,75,32,51,22,55,17,43,14,71,02,59
 .BYTE 27,73,36,49,24,77,25,59,34,48,26,58,08,56
 .BYTE 18,74,29,65,37,64,09,76,33,57,19,42,31,54
 .BYTE 03,47,15,62,11,72,35,45,38,68,13,47,06,52
 .BYTE 23,61,04,79,30,41,00,56,20,50
;
;
; *** CONSTANT FOR BIT OPERATION ***
;
ALL:	.EQU	$FF
BIT0:	.EQU	$01
BIT1:	.EQU	$02
BIT2:	.EQU	$04
BIT3:	.EQU	$08
BIT4:	.EQU	$10
BIT5:	.EQU	$20
BIT6:	.EQU	$40
BIT7:	.EQU	$80
;
; *** FDC 5710 REGISTERS LOCATIONS ***
;
MFMREG0:.EQU	$2000
MFMREG1:.EQU	$2001
MFMREG2:.EQU	$2002
MFMREG3:.EQU	$2003
MFMREG4:.EQU	$2004
MFMREG5:.EQU	$2005
;
; *** SCRATCH PAD RAM ON FDC 5710 ***
;
AM:	.EQU	$4010
IDAM:	.EQU	$4012
DAM:	.EQU	$4014
;
; *** DOS ROUTINES FOR FDC 5710 ***
;
XMS:	.EQU	$8829
SET_HDR:.EQU	$8F6C
SYN_AM: .EQU	$AC38
SRCH_HDR:.EQU	$AC9C
WAIT_GAP:.EQU	$ACB9
;
;
; *** START OF READ, WRITE & VERIFY ROUTINES FOR 1571CR ***
;     REFERENCE: 1571CR DOS ROM LISTING,
;		    $8D65 CMDNIN	;READ SECTOR
;		    $8E0A CMDTEN	;WRITE SECTOR
;		    $ACC7 CMDELE	;VERIFY
;		 5710 SPECIFICATION
;   	 	 READ, WRITE & VERIFY ROUTINES OF JTP-047
;
QUE:	LDA	OPRTYP
	AND	#$3F
	CMP	#$0A
	BEQ	CMDTEN
CMDNIN:	LDA	#$00
	STA	RDVR
	JMP	RDORVR
;
;
CMDTEN: JMP	WRTE
;
WRTE: 	JSR	SET_HDR
	JSR	SRCH_HDR
	BCC	W8
	JMP	W15
W8:	JSR	WAIT_GAP
	LDA	#BIT5+BIT3
	STA	MFMREG0
	STX	MFMREG2
	LDA	MFMREG0
	ORA	#BIT1
	STA	MFMREG0
	TXA		;X= 0
	LDX	#$0C
W10:	JSR	BLOCK
	LDA	AM
	JSR	WR1BYTE
	LDA	MFMREG0
	ORA	#BIT4+BIT2
	STA	MFMREG0
	LDA	MFMREG1
	AND	#ALL-BIT2-BIT1-BIT0
	ORA	IDAM
	STA	MFMREG1
	LDX	#$02
	LDA	AM
W11:	JSR	BLOCK
	LDA	DAM
	JSR 	WR1BYTE
	LDY	#ALL-BIT2
	JSR	MAND
	LDY	#$00
W11_5:	LDA	PATERN	;GET PATTERN WRITTEN
	BIT	OPRTYP
	BVC	W13
W12:	LDA	(BUFPNT),Y
W13:	JSR 	WR1BYTE
	INY
	BNE	W11_5
W14:	JSR	WR1BYTE
	LDY	#ALL-BIT3
	JSR	MAND
	LDX	#$03
	JSR	BLOCK
	LDY	#ALL-BIT4
	JSR	MAND
	JSR	WR1BYTE
	LDY	#ALL-BIT5-BIT4-BIT1
	JSR	MAND
	LDY	#$02
	JSR	XMS
;	LDX	#$00
	JSR	CMDELE
	.DB	2CH
W15:	LDX	#$07
W16:	STX	MFMCMD
	RTS
;
;
WR1BYTE:BIT	MFMREG0
	BPL	WR1BYTE
	STA	MFMREG2
	RTS
;
;
MAND:	TYA
	AND	MFMREG0
	STA	MFMREG0
	RTS
;
;
BLOCK:	JSR	WR1BYTE
	DEX
	BNE	BLOCK
	RTS
;
;
CMDELE:	LDA	#$FF
	STA	RDVR
	JMP	RDORVR
;
;
;
; *** THIS ROUTINE USED BY CMDTEN & CMDELE ***
;
;     IF RDVR = 00 THEN RDORVR = CMDTEN
;     IF RDVR = FF THEN RDORVR = CMDELE
;
RDORVR:
	LDA	#$0A	;RETRY 10 TIMES IF ERROR MET
	STA	MRETRY
R1:	JSR	SET_HDR
	JSR	SRCH_HDR
	BCC	R2
	BIT	RDVR
	BVC	R8
	BVS	R6_3
R2:	JSR	SYN_AM
	BCS	R6
	LDY	#$00
R3:	JSR	RD1BYTE
	BIT	RDVR
	BVC	RD
	BIT	OPRTYP
	BVC	R4
R3_5:	CMP	(BUFPNT),Y
	BNE	R6_3
	BEQ	R5
R4:	CMP	PATERN
	BNE	R6_3
R5:	INY
	BNE	R3
	BEQ	CONT
RD:	BIT	OPRTYP
	BVC	NLG
	STA	(BUFPNT),Y
NLG:	INY
	BNE	R3
CONT:	JSR	RD1BYTE
	JSR	RD1BYTE
	LDA	#BIT4+BIT3
	STA	MFMREG1
	JSR	RD1BYTE
	LDA	MFMREG1
	AND	#BIT5
	BEQ	R7
	LDX	#$05
	BNE	R6_5
R6:	LDX	#$03
	BIT	RDVR
	BVC	R6_5
R6_3:	LDX	#$07
R6_5:	DEC	MRETRY
	BNE	R1
	.DB	2CH
R7:	LDX	#$00
	STX	MFMCMD
R8: 	RTS
;
;
RD1BYTE:BIT	MFMREG1
	BPL	RD1BYTE
	LDA	MFMREG2
	RTS
;
;
	END	MFM_SFTERR.ASM_WD5710

